<template>
  <div class="w-3/4 mx-auto pt-30px">
    <BasicForm @register="register" />
  </div>
</template>
<script lang="ts" setup>
  import { inject } from 'vue';
  import { getFormTemplateList } from '/@/api/form/design';
  import { getSystemAllList } from '/@/api/system/subSystem';
  import { getMenuTree } from '/@/api/system/menu';
  import { FormSchema, useForm, BasicForm } from '/@/components/Form';
  import { FormReleaseConfig, GeneratorConfig } from '/@/model/generator/generatorConfig';
  import { FormTypeEnum } from '/@/enums/formtypeEnum';
  import { useI18n } from '/@/hooks/web/useI18n';
  import { useMessage } from '/@/hooks/web/useMessage';

  const { notification } = useMessage();

  const { t } = useI18n();
  defineEmits(['register']);

  const formReleaseConfig = inject<FormReleaseConfig>('formReleaseConfig') as FormReleaseConfig;
  const generatorConfig = inject<GeneratorConfig>('generatorConfig') as GeneratorConfig;

  const formSchema: FormSchema[] = [
    {
      field: 'code',
      label: t('菜单编号'),
      required: true,
      component: 'Input',
      colProps: { span: 12 },
    },
    {
      field: 'name',
      label: t('菜单名称'),
      required: true,
      component: 'Input',
      colProps: { span: 12 },
    },
    {
      field: 'systemId',
      label: '主子系统',
      component: 'ApiSelect',
      required: true,
      componentProps: ({ formModel, formActionType }) => {
        return {
          api: getSystemAllList,
          labelField: 'name',
          valueField: 'id',
          params: {
            hasMainSystem: !(import.meta.env.VITE_GLOB_PRODUCTION === 'true'),
          },
          getPopupContainer: () => document.body,
          showSearch: true,
          onChange: async (val) => {
            formModel.parentId = '';
            const { updateSchema } = formActionType;
            updateSchema({
              field: 'parentId',
              componentProps: {
                api: val ? getMenuTree : '',
                params: { systemId: val },
                fieldNames: {
                  key: 'id',
                  label: 'title',
                  value: 'id',
                },
              },
            });
          },
        };
      },
      colProps: { span: 12 },
    },
    {
      field: 'parentId',
      label: t('上级菜单'),
      component: 'ApiTreeSelect',
      componentProps: ({ formModel }) => {
        return {
          api: formModel.systemId ? getMenuTree : '',
          params: { systemId: formModel.systemId },
          fieldNames: {
            key: 'id',
            label: 'title',
            value: 'id',
          },
          getPopupContainer: () => document.body,
        };
      },
      colProps: { span: 12 },
    },
    {
      field: 'formId',
      label: t('表单选择'),
      required: true,
      component: 'ApiSelect',
      componentProps: {
        api: getFormTemplateList,
        // use name as label
        labelField: 'name',
        // use id as value
        valueField: 'id',
        getPopupContainer: () => document.body,
        params: {
          type: FormTypeEnum.CUSTOM_FORM,
          status: 1,
          enabledMark: 1,
        },
        onChange: () => {
          generatorConfig.listConfig.buttonConfigs = [];
        },
        showSearch: true,
      },
      colProps: { span: 12 },
    },
    {
      field: 'sortCode',
      label: t('排序'),
      required: true,
      component: 'InputNumber',
      componentProps: {
        style: { width: '100%' },
      },
      colProps: { span: 12 },
    },
    {
      field: 'icon',
      label: t('图标'),
      required: true,
      component: 'IconPicker',
      colProps: { span: 12 },
    },

    {
      field: 'remark',
      label: t('备注'),
      component: 'InputTextArea',
      colProps: { span: 12 },
    },
  ];
  const [register, { validate, setFieldsValue }] = useForm({
    labelWidth: 100,
    schemas: formSchema,
    showActionButtonGroup: false,
    layout: 'vertical',
    rowProps: {
      gutter: 50,
    },
    wrapperCol: {
      style: { paddingBottom: '6px' },
    },
  });

  //验证当前步骤的数据
  const validateStep = async (): Promise<boolean> => {
    try {
      const formData = await validate();
      if (formData.code.length > 10) {
        notification.error({
          message: t('提示'),
          description: '编号长度不能超过10个字符',
        }); //提示消息
        return false;
      }
      formReleaseConfig.menuConfig.code = formData.code;
      formReleaseConfig.menuConfig.name = formData.name;
      formReleaseConfig.menuConfig.parentId = formData.parentId;
      formReleaseConfig.menuConfig.remark = formData.remark;
      formReleaseConfig.menuConfig.sortCode = formData.sortCode;
      formReleaseConfig.menuConfig.icon = formData.icon;
      formReleaseConfig.menuConfig.systemId = formData.systemId;
      formReleaseConfig.formId = formData.formId;
    } catch (error) {
      return false;
    }
    return true;
  };

  defineExpose({ validateStep, setFieldsValue });
</script>
